#include "RB_PCM.h"

int main(int argc, char *argv[])
{
    unsigned int samplerate, sr;
    int OCT, FNS;
    unsigned short pitch, p;
    
    if(argc >= 4) {
        samplerate = atoi(argv[1]);
        OCT = atoi(argv[2]);
        FNS = atoi(argv[3]);
        pitch = PCM_toPitch(OCT, FNS);
    } else {
        printf("Usage: TestPitch sr OCT FNS");    
        return 0;
    }    
    
    p = PCM_computePitch((double)samplerate);
    sr = PCM_computeSampleRate(pitch);

    printf("samplerate %i -> pitch %x = OCT %i + FNS %i\n", (int)samplerate, p, PCM_toSXT4(PCM_toOCT(p)), PCM_toFNS(p));
    printf("OCT %i + FNS %i = pitch %x -> samplerate %i\n", OCT, FNS, pitch, sr);
        
    
    return 1;
}
